﻿#region using statements
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace visLU
{
    /// <summary>
    ///
    /// </summary>
    public struct EngineState
    {
        public bool updateCamera;
        public bool loadData;
        public bool updateData;
        public bool drawData;

        public EngineState(bool _updateCamera, bool _loadData, bool _updateData, bool _drawdata)
        {
            updateCamera = _updateCamera;
            loadData = _loadData;
            updateData = _updateData;
            drawData = _drawdata;
        }
       
    }

    /// <summary>
    ///
    /// </summary>
    public enum ViewMode
    {
        //Default = 0, //3d view + slicing views
        VolView = 0,     //3d view
        TopView,     //top view -> y slice
        SideView,    //side view -> x slice
        FrontView    //front view -> z slice
    };

    /// <summary>
    ///
    /// </summary>
    public sealed class GameProperties
    {

        static GameProperties instance = new GameProperties();

        #region game and engine states
        public bool startGame = false;
        public bool exitGame = false;
        public bool updateGuiForm = false;
        public bool fullscreen = false;
        public EngineState engineState = new EngineState(true, false, true, true);
        #endregion

        #region xna draw window
        public int GuiWindowWidth = 1024;
        public int GuiWindowHeight = 768;
        public int XNADrawSurfaceWidth = 700;
        public int XNADrawSurfaceHeight = 700;
        public int fullscreenWidth = 1024;
        public int fullscreenHeight = 786;
        public Viewport XNAViewport;
        #endregion

        #region transfer function
        public bool enableTransferFunction = true;
        public bool enableTransferAlphaValues = true;
        public float[] distinctDensityValues;
        public int[] countDensityValues;
        public List<TransferControlPoint> colorControlPoints = new List<TransferControlPoint>();
        public List<TransferControlPoint> alphaControlPoints = new List<TransferControlPoint>();
        public Color[] colorArray;
        public float[] alphaArray;
        public bool updateColorBar = false;
        #endregion

        #region gui input
        //main menu
        public String dataDir = "Data\\";
        public String dataFilename = "lobster.dat";
        //public String dataFilename = "skewed_head.dat";
        public String saveFilename = "Data\\Screenshots";
        public bool saveView = false;

        //view panel
        public ViewMode viewMode = ViewMode.VolView; //default: 3d view

        //slice setup
        public int xDataRange = 100;
        public int yDataRange = 100;
        public int zDataRange = 100;
        public float xSliceValue = 0.5f;
        public float ySliceValue = 0.5f;
        public float zSliceValue = 0.5f;
        
        //clipping plane setup
        public bool enableClippingPlane = false;

        //projection setup

        //shader parameters

        public bool perspectiveProjection = true;
        public bool maximumIntensityProjection = false;
        //public bool frontToBack = true;
        //public bool shading = true;
        //public bool useAlpha = true; 

        //Blending
        public bool enableFrontToBackBlend = true;

        //Shading on/off
        public bool enableShading = true;

        //Gradient stuff
        public int gradientSampleSize = 1;

        //move camera in 3d view
        //x,y -> cursor position, z ->scroll step for zooming option
        public Vector3 position = Vector3.Zero;
        public Vector3 dataOrigin = Vector3.Zero; //new Vector3(0.5f, 0.5f, 0.0f);
        #endregion
           
        //--------------------------------------------------------------
        public static GameProperties Instance
        {
            get
            {
                return instance;
            }
        }

        private static void calculateViewportDimension()
        {

        }

        static GameProperties(){}

        GameProperties(){}
    }
}
