﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace visLU.Gui
{
    /// <summary>
    ///
    /// </summary>
    public partial class SlicingForm : Form
    {
        InputManager inputManager;

        private MainWindow mainForm;

        /// <summary>
        ///
        /// </summary>
        public SlicingForm()
        {
            InitializeComponent();
            inputManager = new InputManager();
            //XSliceGroup.Enabled = inputManager.enableSliceGroup(1);
            //YSliceGroup.Enabled = inputManager.enableSliceGroup(2);
            //ZSliceGroup.Enabled = inputManager.enableSliceGroup(3);
        }

        /// <summary>
        ///
        /// </summary>
        public MainWindow MainForm
        {
            set { mainForm = value; }
        }

        /// <summary>
        ///
        /// </summary>
        /// <param name="slice"></param>
        /// <param name="increment"></param>
        /// <param name="decimalPlaces"></param>
        /// <param name="value"></param>
        public void setSlicingGroups(int slice, Decimal increment, int decimalPlaces, Decimal value)
        {
            switch (slice)
            {
                case 1:
                    XSliceNumericUpDown.Increment = increment;
                    XSliceNumericUpDown.DecimalPlaces = decimalPlaces;
                    XSliceNumericUpDown.Value = value;
                    break;
                case 2:
                    YSliceNumericUpDown.Increment = increment;
                    YSliceNumericUpDown.DecimalPlaces = decimalPlaces;
                    YSliceNumericUpDown.Value = value;
                    break;
                case 3:
                    ZSliceNumericUpDown.Increment = increment;
                    ZSliceNumericUpDown.DecimalPlaces = decimalPlaces;
                    ZSliceNumericUpDown.Value = value;
                    break;
                default:
                    break;

            }

        }

        /// <summary>
        ///
        /// </summary>
        /// <param name="slice"></param>
        /// <param name="maximum"></param>
        /// <param name="value"></param>
        public void setSlicingGroups(int slice, int maximum, int value)
        {
            switch (slice)
            {
                case 1:
                    XSlider.Maximum = maximum;
                    XSlider.Value = value;
                    break;
                case 2:
                    YSlider.Maximum = maximum;
                    YSlider.Value = value;
                    break;
                case 3:
                    ZSlider.Maximum = maximum;
                    ZSlider.Value = value;
                    break;
                default:
                    break;

            }

        }

        #region event handler
        /// <summary>
        ///
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void handleSliceNumericUpDown(object sender, EventArgs e)
        {
            if (sender == XSliceNumericUpDown)
            {
                XSlider.Value = Decimal.ToInt32(Decimal.Multiply(XSliceNumericUpDown.Value, new Decimal(XSlider.Maximum)));
                inputManager.setSliceValue(1, XSliceNumericUpDown.Value);

            }
            else if (sender == YSliceNumericUpDown)
            {
                YSlider.Value = Decimal.ToInt32(Decimal.Multiply(YSliceNumericUpDown.Value, new Decimal(YSlider.Maximum)));
                inputManager.setSliceValue(2, YSliceNumericUpDown.Value);

            }
            else if (sender == ZSliceNumericUpDown)
            {
                ZSlider.Value = Decimal.ToInt32(Decimal.Multiply(ZSliceNumericUpDown.Value, new Decimal(ZSlider.Maximum)));
                inputManager.setSliceValue(3, ZSliceNumericUpDown.Value);

            }
        }

        /// <summary>
        ///
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void handleScrollSlider(object sender, EventArgs e)
        {
            if (sender == XSlider)
            {
                Decimal newValue = Decimal.Divide(new Decimal(XSlider.Value), new Decimal(XSlider.Maximum));
                XSliceNumericUpDown.Value = newValue;
                inputManager.setSliceValue(1, newValue);

            }
            else if (sender == YSlider)
            {
                Decimal newValue = Decimal.Divide(new Decimal(YSlider.Value), new Decimal(YSlider.Maximum));
                YSliceNumericUpDown.Value = newValue;
                inputManager.setSliceValue(2, newValue);

            }
            else if (sender == ZSlider)
            {
                Decimal newValue = Decimal.Divide(new Decimal(ZSlider.Value), new Decimal(ZSlider.Maximum));
                ZSliceNumericUpDown.Value = newValue;
                inputManager.setSliceValue(3, newValue);

            }
        }

        /// <summary>
        ///
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void handleSlicingFormOnClosing(object sender, FormClosingEventArgs e)
        {
                mainForm.setSlicingGroups(1, XSliceNumericUpDown.Increment, XSliceNumericUpDown.DecimalPlaces, XSliceNumericUpDown.Value);
                mainForm.setSlicingGroups(2, YSliceNumericUpDown.Increment, YSliceNumericUpDown.DecimalPlaces, YSliceNumericUpDown.Value);
                mainForm.setSlicingGroups(3, ZSliceNumericUpDown.Increment, YSliceNumericUpDown.DecimalPlaces, ZSliceNumericUpDown.Value);
                mainForm.setSlicingGroups(1, XSlider.Maximum, XSlider.Value);
                mainForm.setSlicingGroups(2, YSlider.Maximum, YSlider.Value);
                mainForm.setSlicingGroups(3, ZSlider.Maximum, ZSlider.Value);
        
        }

        private void SlicingForm_Enter(object sender, EventArgs e)
        {
            XSliceGroup.Enabled = inputManager.enableSliceGroup(1);
            YSliceGroup.Enabled = inputManager.enableSliceGroup(2);
            ZSliceGroup.Enabled = inputManager.enableSliceGroup(3);
        }

        #endregion

      
        
    }
}
